org.apache.pdfbox.pdmodel.documentinterchange.taggedpdf

## Class PDLayoutAttributeObject

- java.lang.Object
- - org.apache.pdfbox.pdmodel.common.PDDictionaryWrapper
  - - org.apache.pdfbox.pdmodel.documentinterchange.logicalstructure.PDAttributeObject
    - - org.apache.pdfbox.pdmodel.documentinterchange.taggedpdf.PDStandardAttributeObject
      - - org.apache.pdfbox.pdmodel.documentinterchange.taggedpdf.PDLayoutAttributeObject

All Implemented Interfaces:
  COSObjectable

Direct Known Subclasses:
  PDExportFormatAttributeObject

    public class PDLayoutAttributeObject
    extends PDStandardAttributeObject

A Layout attribute object.

Author:
  Johannes Koch

### Field Summary

Fields
`static String` `BLOCK_ALIGN_AFTER` BlockAlign: After: After edge of the last child’s allocation rectangle aligned with that of the table cell’s content rectangle.
`static String` `BLOCK_ALIGN_BEFORE` BlockAlign: Before: Before edge of the first child’s allocation rectangle aligned with that of the table cell’s content rectangle.
`static String` `BLOCK_ALIGN_JUSTIFY` BlockAlign: Justify: Children aligned with both the before and after edges of the table cell’s content rectangle.
`static String` `BLOCK_ALIGN_MIDDLE` BlockAlign: Middle: Children centered within the table cell.
`static String` `BORDER_STYLE_DASHED` BorderStyle: Dashed: The border is a series of short line segments.
`static String` `BORDER_STYLE_DOTTED` BorderStyle: Dotted: The border is a series of dots.
`static String` `BORDER_STYLE_DOUBLE` BorderStyle: Double: The border is two solid lines.
`static String` `BORDER_STYLE_GROOVE` BorderStyle: Groove: The border looks as though it were carved into the canvas.
`static String` `BORDER_STYLE_HIDDEN` BorderStyle: Hidden: Same as `BORDER_STYLE_NONE`, except in terms of border conflict resolution for table elements.
`static String` `BORDER_STYLE_INSET` BorderStyle: Inset: The border makes the entire box look as though it were embedded in the canvas.
`static String` `BORDER_STYLE_NONE` BorderStyle: None: No border.
`static String` `BORDER_STYLE_OUTSET` BorderStyle: Outset: The border makes the entire box look as though it were coming out of the canvas (the opposite of `BORDER_STYLE_INSET`.
`static String` `BORDER_STYLE_RIDGE` BorderStyle: Ridge: The border looks as though it were coming out of the canvas (the opposite of `BORDER_STYLE_GROOVE`).
`static String` `BORDER_STYLE_SOLID` BorderStyle: Solid: The border is a single line segment.
`static String` `GLYPH_ORIENTATION_VERTICAL_180_DEGREES` GlyphOrientationVertical: 180°
`static String` `GLYPH_ORIENTATION_VERTICAL_270_DEGREES` GlyphOrientationVertical: 270°
`static String` `GLYPH_ORIENTATION_VERTICAL_360_DEGREES` GlyphOrientationVertical: 360°
`static String` `GLYPH_ORIENTATION_VERTICAL_90_DEGREES` GlyphOrientationVertical: 90°
`static String` `GLYPH_ORIENTATION_VERTICAL_AUTO` GlyphOrientationVertical: Auto
`static String` `GLYPH_ORIENTATION_VERTICAL_MINUS_180_DEGREES` GlyphOrientationVertical: -180°
`static String` `GLYPH_ORIENTATION_VERTICAL_MINUS_90_DEGREES` GlyphOrientationVertical: -90°
`static String` `GLYPH_ORIENTATION_VERTICAL_ZERO_DEGREES` GlyphOrientationVertical: 0°
`static String` `HEIGHT_AUTO` Height: Auto
`static String` `INLINE_ALIGN_CENTER` InlineAlign: Center: Each child centered within the table cell.
`static String` `INLINE_ALIGN_END` InlineAlign: End: End edge of each child’s allocation rectangle aligned with that of the table cell’s content rectangle.
`static String` `INLINE_ALIGN_START` InlineAlign: Start: Start edge of each child’s allocation rectangle aligned with that of the table cell’s content rectangle.
`static String` `LINE_HEIGHT_AUTO` LineHeight: Auto: Adjustment for the value of BaselineShift shall not be made.
`static String` `LINE_HEIGHT_NORMAL` LineHeight: NormalAdjust the line height to include any nonzero value specified for BaselineShift.
`static String` `OWNER_LAYOUT` standard attribute owner: Layout
`static String` `PLACEMENT_BEFORE` Placement: Before: Placed so that the before edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area.
`static String` `PLACEMENT_BLOCK` Placement: Block: Stacked in the block-progression direction within an enclosing reference area or parent BLSE.
`static String` `PLACEMENT_END` Placement: End: Placed so that the end edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area.
`static String` `PLACEMENT_INLINE` Placement: Inline: Packed in the inline-progression direction within an enclosing BLSE.
`static String` `PLACEMENT_START` Placement: Start: Placed so that the start edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area.
`static String` `RUBY_ALIGN_CENTER` RubyAlign: Center: The content shall be centered in the inline-progression direction.
`static String` `RUBY_ALIGN_DISTRIBUTE` RubyAlign: Distribute: The content shall be expanded to fill the available width in the inline-progression direction.
`static String` `RUBY_ALIGN_END` RubyAlign: End: The content shall be aligned on the end edge in the inline-progression direction.
`static String` `RUBY_ALIGN_JUSTIFY` RubyAlign: Justify: The content shall be expanded to fill the available width in the inline-progression direction.
`static String` `RUBY_ALIGN_START` RubyAlign: Start: The content shall be aligned on the start edge in the inline-progression direction.
`static String` `RUBY_POSITION_AFTER` RubyPosition: After: The RT content shall be aligned along the after edge of the element.
`static String` `RUBY_POSITION_BEFORE` RubyPosition: Before: The RT content shall be aligned along the before edge of the element.
`static String` `RUBY_POSITION_INLINE` RubyPosition: Inline: The RT and associated RP elements shall be formatted as a parenthesis comment, following the RB element.
`static String` `RUBY_POSITION_WARICHU` RubyPosition: Warichu: The RT and associated RP elements shall be formatted as a warichu, following the RB element.
`static String` `TEXT_ALIGN_CENTER` TextAlign: Center: Centered between the start and end edges.
`static String` `TEXT_ALIGN_END` TextAlign: End: Aligned with the end edge.
`static String` `TEXT_ALIGN_JUSTIFY` TextAlign: Justify: Aligned with both the start and end edges, with internal spacing within each line expanded, if necessary, to achieve such alignment.
`static String` `TEXT_ALIGN_START` TextAlign: Start: Aligned with the start edge.
`static String` `TEXT_DECORATION_TYPE_LINE_THROUGH` TextDecorationType: LineThrough: A line through the middle of the text
`static String` `TEXT_DECORATION_TYPE_NONE` TextDecorationType: None: No text decoration
`static String` `TEXT_DECORATION_TYPE_OVERLINE` TextDecorationType: Overline: A line above the text
`static String` `TEXT_DECORATION_TYPE_UNDERLINE` TextDecorationType: Underline: A line below the text
`static String` `WIDTH_AUTO` Width: Auto
`static String` `WRITING_MODE_LRTB` WritingMode: LrTb: Inline progression from left to right; block progression from top to bottom.
`static String` `WRITING_MODE_RLTB` WritingMode: RlTb: Inline progression from right to left; block progression from top to bottom.
`static String` `WRITING_MODE_TBRL` WritingMode: TbRl: Inline progression from top to bottom; block progression from right to left.

### Fields inherited from class org.apache.pdfbox.pdmodel.documentinterchange.taggedpdf.PDStandardAttributeObject

`UNSPECIFIED`

### Constructor Summary

Constructors
Constructor and Description
`PDLayoutAttributeObject()` Default constructor.
`PDLayoutAttributeObject(COSDictionary dictionary)` Creates a new Layout attribute object with a given dictionary.

### Method Summary

All Methods Instance Methods Concrete Methods
`PDGamma` `getBackgroundColor()` Gets the background colour (BackgroundColor).
`float` `getBaselineShift()` Gets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift).
`PDRectangle` `getBBox()` Gets the bounding box.
`String` `getBlockAlign()` Gets the alignment, in the block-progression direction, of content within the table cell (BlockAlign).
`Object` `getBorderColors()` Gets the border colour (BorderColor).
`Object` `getBorderStyle()` Gets the border style (BorderStyle).
`Object` `getBorderThickness()` Gets the border thickness (BorderThickness).
`PDGamma` `getColor()` Gets the color to be used for drawing text and the default value for the colour of table borders and text decorations (Color).
`int` `getColumnCount()` Gets the number of columns in the content of the grouping element (ColumnCount).
`Object` `getColumnGap()` Gets the desired space between adjacent columns in the inline-progression direction (ColumnGap).
`Object` `getColumnWidths()` Gets the desired width of the columns, measured in default user space units in the inline-progression direction (ColumnWidths).
`float` `getEndIndent()` Gets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent).
`String` `getGlyphOrientationVertical()` Gets the orientation of glyphs when the inline-progression direction is top to bottom or bottom to top (GlyphOrientationVertical).
`Object` `getHeight()` Gets the height of the element’s content rectangle in the block-progression direction (Height).
`String` `getInlineAlign()` Gets the alignment, in the inline-progression direction, of content within the table cell (InlineAlign).
`Object` `getLineHeight()` Gets the element’s preferred height in the block-progression direction (LineHeight).
`Object` `getPadding()` Gets the padding (Padding).
`String` `getPlacement()` Gets the positioning of the element with respect to the enclosing reference area and other content (Placement).
`String` `getRubyAlign()` Gets the justification of the lines within a ruby assembly (RubyAlign).
`String` `getRubyPosition()` Gets the placement of the RT structure element relative to the RB element in a ruby assembly (RubyPosition).
`float` `getSpaceAfter()` Gets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter).
`float` `getSpaceBefore()` Gets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore).
`float` `getStartIndent()` Gets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent).
`Object` `getTBorderStyle()` Gets the style of the border drawn on each edge of a table cell (TBorderStyle).
`String` `getTextAlign()` Gets the alignment, in the inline-progression direction, of text and other content within lines of the BLSE (TextAlign).
`PDGamma` `getTextDecorationColor()` Gets the colour to be used for drawing text decorations (TextDecorationColor).
`float` `getTextDecorationThickness()` Gets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).
`String` `getTextDecorationType()` Gets the type of text decoration (TextDecorationType).
`float` `getTextIndent()` Gets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent).
`Object` `getTPadding()` Gets the offset to account for the separation between the table cell’s content rectangle and the surrounding border (TPadding).
`Object` `getWidth()` Gets the width of the element’s content rectangle in the inline-progression direction (Width).
`String` `getWritingMode()` Gets the writing mode (WritingMode).
`void` `setAllBorderColors(PDGamma borderColor)` Sets the same border colour for all four sides (BorderColor).
`void` `setAllBorderStyles(String borderStyle)` Sets the same border style for all four sides (BorderStyle).
`void` `setAllBorderThicknesses(float borderThickness)` Sets the same border thickness for all four sides (BorderThickness).
`void` `setAllBorderThicknesses(int borderThickness)` Sets the same border thickness for all four sides (BorderThickness).
`void` `setAllColumnWidths(float columnWidth)` Sets the same column width for all columns (ColumnWidths).
`void` `setAllColumnWidths(int columnWidth)` Sets the same column width for all columns (ColumnWidths).
`void` `setAllPaddings(float padding)` Sets the same padding for all four sides (Padding).
`void` `setAllPaddings(int padding)` Sets the same padding for all four sides (Padding).
`void` `setAllTBorderStyles(String tBorderStyle)` Sets the same table border style for all four sides (TBorderStyle).
`void` `setAllTPaddings(float tPadding)` Sets the same table padding for all four sides (TPadding).
`void` `setAllTPaddings(int tPadding)` Sets the same table padding for all four sides (TPadding).
`void` `setBackgroundColor(PDGamma backgroundColor)` Sets the background colour (BackgroundColor).
`void` `setBaselineShift(float baselineShift)` Sets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift).
`void` `setBaselineShift(int baselineShift)` Sets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift).
`void` `setBBox(PDRectangle bbox)` Sets the bounding box.
`void` `setBlockAlign(String blockAlign)` Sets the alignment, in the block-progression direction, of content within the table cell (BlockAlign).
`void` `setBorderColors(PDFourColours borderColors)` Sets the border colours for four sides separately (BorderColor).
`void` `setBorderStyles(String[] borderStyles)` Sets the border styles for four sides separately (BorderStyle).
`void` `setBorderThicknesses(float[] borderThicknesses)` Sets the border thicknesses for four sides separately (BorderThickness).
`void` `setColor(PDGamma color)` Sets the color to be used for drawing text and the default value for the colour of table borders and text decorations (Color).
`void` `setColumnCount(int columnCount)` Sets the number of columns in the content of the grouping element (ColumnCount).
`void` `setColumnGap(float columnGap)` Sets the desired space between all columns in the inline-progression direction (ColumnGap).
`void` `setColumnGap(int columnGap)` Sets the desired space between all columns in the inline-progression direction (ColumnGap).
`void` `setColumnGaps(float[] columnGaps)` Sets the desired space between adjacent columns in the inline-progression direction (ColumnGap), the first element specifying the space between the first and second columns, the second specifying the space between the second and third columns, and so on.
`void` `setColumnWidths(float[] columnWidths)` Sets the column widths for the columns separately (ColumnWidths).
`void` `setEndIndent(float endIndent)` Sets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent).
`void` `setEndIndent(int endIndent)` Sets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent).
`void` `setGlyphOrientationVertical(String glyphOrientationVertical)` Sets the orientation of glyphs when the inline-progression direction is top to bottom or bottom to top (GlyphOrientationVertical).
`void` `setHeight(float height)` Sets the height of the element’s content rectangle in the block-progression direction (Height).
`void` `setHeight(int height)` Sets the height of the element’s content rectangle in the block-progression direction (Height).
`void` `setHeightAuto()` Sets the height of the element’s content rectangle in the block-progression direction (Height) to `HEIGHT_AUTO`.
`void` `setInlineAlign(String inlineAlign)` Sets the alignment, in the inline-progression direction, of content within the table cell (InlineAlign).
`void` `setLineHeight(float lineHeight)` Sets the element’s preferred height in the block-progression direction (LineHeight).
`void` `setLineHeight(int lineHeight)` Sets the element’s preferred height in the block-progression direction (LineHeight).
`void` `setLineHeightAuto()` Sets the element’s preferred height in the block-progression direction (LineHeight) to `LINE_HEIGHT_AUTO`.
`void` `setLineHeightNormal()` Sets the element’s preferred height in the block-progression direction (LineHeight) to `LINE_HEIGHT_NORMAL`.
`void` `setPaddings(float[] paddings)` Sets the paddings for four sides separately (Padding).
`void` `setPlacement(String placement)` Sets the positioning of the element with respect to the enclosing reference area and other content (Placement).
`void` `setRubyAlign(String rubyAlign)` Sets the justification of the lines within a ruby assembly (RubyAlign).
`void` `setRubyPosition(String rubyPosition)` Sets the placement of the RT structure element relative to the RB element in a ruby assembly (RubyPosition).
`void` `setSpaceAfter(float spaceAfter)` Sets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter).
`void` `setSpaceAfter(int spaceAfter)` Sets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter).
`void` `setSpaceBefore(float spaceBefore)` Sets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore).
`void` `setSpaceBefore(int spaceBefore)` Sets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore).
`void` `setStartIndent(float startIndent)` Sets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent).
`void` `setStartIndent(int startIndent)` Sets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent).
`void` `setTBorderStyles(String[] tBorderStyles)` Sets the style of the border drawn on each edge of a table cell (TBorderStyle).
`void` `setTextAlign(String textIndent)` Sets the alignment, in the inline-progression direction, of text and other content within lines of the BLSE (TextAlign).
`void` `setTextDecorationColor(PDGamma textDecorationColor)` Sets the colour to be used for drawing text decorations (TextDecorationColor).
`void` `setTextDecorationThickness(float textDecorationThickness)` Sets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).
`void` `setTextDecorationThickness(int textDecorationThickness)` Sets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).
`void` `setTextDecorationType(String textDecorationType)` Sets the type of text decoration (TextDecorationType).
`void` `setTextIndent(float textIndent)` Sets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent).
`void` `setTextIndent(int textIndent)` Sets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent).
`void` `setTPaddings(float[] tPaddings)` Sets the table paddings for four sides separately (TPadding).
`void` `setWidth(float width)` Sets the width of the element’s content rectangle in the inline-progression direction (Width).
`void` `setWidth(int width)` Sets the width of the element’s content rectangle in the inline-progression direction (Width).
`void` `setWidthAuto()` Sets the width of the element’s content rectangle in the inline-progression direction (Width) to `WIDTH_AUTO`.
`void` `setWritingMode(String writingMode)` Sets the writing mode (WritingMode).
`String` `toString()`

### Methods inherited from class org.apache.pdfbox.pdmodel.documentinterchange.taggedpdf.PDStandardAttributeObject

`getArrayOfString, getColor, getColorOrFourColors, getInteger, getName, getName, getNameOrArrayOfName, getNumber, getNumber, getNumberOrArrayOfNumber, getNumberOrName, getString, isSpecified, setArrayOfName, setArrayOfNumber, setArrayOfString, setColor, setFourColors, setInteger, setName, setNumber, setNumber, setString`

### Methods inherited from class org.apache.pdfbox.pdmodel.documentinterchange.logicalstructure.PDAttributeObject

`arrayToString, arrayToString, create, getOwner, isEmpty, notifyChanged, potentiallyNotifyChanged, setOwner, setStructureElement`

### Methods inherited from class org.apache.pdfbox.pdmodel.common.PDDictionaryWrapper

`equals, getCOSObject, hashCode`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### OWNER_LAYOUT

    public static final String OWNER_LAYOUT

standard attribute owner: Layout

See Also:
  Constant Field Values

#### PLACEMENT_BLOCK

    public static final String PLACEMENT_BLOCK

Placement: Block: Stacked in the block-progression direction within an enclosing reference area or parent BLSE.

See Also:
  Constant Field Values

#### PLACEMENT_INLINE

    public static final String PLACEMENT_INLINE

Placement: Inline: Packed in the inline-progression direction within an enclosing BLSE.

See Also:
  Constant Field Values

#### PLACEMENT_BEFORE

    public static final String PLACEMENT_BEFORE

Placement: Before: Placed so that the before edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area. The element may float, if necessary, to achieve the specified placement. The element shall be treated as a block occupying the full extent of the enclosing reference area in the inline direction. Other content shall be stacked so as to begin at the after edge of the element’s allocation rectangle.

See Also:
  Constant Field Values

#### PLACEMENT_START

    public static final String PLACEMENT_START

Placement: Start: Placed so that the start edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area. The element may float, if necessary, to achieve the specified placement. Other content that would intrude into the element’s allocation rectangle shall be laid out as a runaround.

See Also:
  Constant Field Values

#### PLACEMENT_END

    public static final String PLACEMENT_END

Placement: End: Placed so that the end edge of the element’s allocation rectangle coincides with that of the nearest enclosing reference area. The element may float, if necessary, to achieve the specified placement. Other content that would intrude into the element’s allocation rectangle shall be laid out as a runaround.

See Also:
  Constant Field Values

#### WRITING_MODE_LRTB

    public static final String WRITING_MODE_LRTB

WritingMode: LrTb: Inline progression from left to right; block progression from top to bottom. This is the typical writing mode for Western writing systems.

See Also:
  Constant Field Values

#### WRITING_MODE_RLTB

    public static final String WRITING_MODE_RLTB

WritingMode: RlTb: Inline progression from right to left; block progression from top to bottom. This is the typical writing mode for Arabic and Hebrew writing systems.

See Also:
  Constant Field Values

#### WRITING_MODE_TBRL

    public static final String WRITING_MODE_TBRL

WritingMode: TbRl: Inline progression from top to bottom; block progression from right to left. This is the typical writing mode for Chinese and Japanese writing systems.

See Also:
  Constant Field Values

#### BORDER_STYLE_NONE

    public static final String BORDER_STYLE_NONE

BorderStyle: None: No border. Forces the computed value of BorderThickness to be 0.

See Also:
  Constant Field Values

#### BORDER_STYLE_HIDDEN

    public static final String BORDER_STYLE_HIDDEN

BorderStyle: Hidden: Same as `BORDER_STYLE_NONE`, except in terms of border conflict resolution for table elements.

See Also:
  Constant Field Values

#### BORDER_STYLE_DOTTED

    public static final String BORDER_STYLE_DOTTED

BorderStyle: Dotted: The border is a series of dots.

See Also:
  Constant Field Values

#### BORDER_STYLE_DASHED

    public static final String BORDER_STYLE_DASHED

BorderStyle: Dashed: The border is a series of short line segments.

See Also:
  Constant Field Values

#### BORDER_STYLE_SOLID

    public static final String BORDER_STYLE_SOLID

BorderStyle: Solid: The border is a single line segment.

See Also:
  Constant Field Values

#### BORDER_STYLE_DOUBLE

    public static final String BORDER_STYLE_DOUBLE

BorderStyle: Double: The border is two solid lines. The sum of the two lines and the space between them equals the value of BorderThickness.

See Also:
  Constant Field Values

#### BORDER_STYLE_GROOVE

    public static final String BORDER_STYLE_GROOVE

BorderStyle: Groove: The border looks as though it were carved into the canvas.

See Also:
  Constant Field Values

#### BORDER_STYLE_RIDGE

    public static final String BORDER_STYLE_RIDGE

BorderStyle: Ridge: The border looks as though it were coming out of the canvas (the opposite of `BORDER_STYLE_GROOVE`).

See Also:
  Constant Field Values

#### BORDER_STYLE_INSET

    public static final String BORDER_STYLE_INSET

BorderStyle: Inset: The border makes the entire box look as though it were embedded in the canvas.

See Also:
  Constant Field Values

#### BORDER_STYLE_OUTSET

    public static final String BORDER_STYLE_OUTSET

BorderStyle: Outset: The border makes the entire box look as though it were coming out of the canvas (the opposite of `BORDER_STYLE_INSET`.

See Also:
  Constant Field Values

#### TEXT_ALIGN_START

    public static final String TEXT_ALIGN_START

TextAlign: Start: Aligned with the start edge.

See Also:
  Constant Field Values

#### TEXT_ALIGN_CENTER

    public static final String TEXT_ALIGN_CENTER

TextAlign: Center: Centered between the start and end edges.

See Also:
  Constant Field Values

#### TEXT_ALIGN_END

    public static final String TEXT_ALIGN_END

TextAlign: End: Aligned with the end edge.

See Also:
  Constant Field Values

#### TEXT_ALIGN_JUSTIFY

    public static final String TEXT_ALIGN_JUSTIFY

TextAlign: Justify: Aligned with both the start and end edges, with internal spacing within each line expanded, if necessary, to achieve such alignment. The last (or only) line shall be aligned with the start edge only.

See Also:
  Constant Field Values

#### WIDTH_AUTO

    public static final String WIDTH_AUTO

Width: Auto

See Also:
  Constant Field Values

#### HEIGHT_AUTO

    public static final String HEIGHT_AUTO

Height: Auto

See Also:
  Constant Field Values

#### BLOCK_ALIGN_BEFORE

    public static final String BLOCK_ALIGN_BEFORE

BlockAlign: Before: Before edge of the first child’s allocation rectangle aligned with that of the table cell’s content rectangle.

See Also:
  Constant Field Values

#### BLOCK_ALIGN_MIDDLE

    public static final String BLOCK_ALIGN_MIDDLE

BlockAlign: Middle: Children centered within the table cell. The distance between the before edge of the first child’s allocation rectangle and that of the table cell’s content rectangle shall be the same as the distance between the after edge of the last child’s allocation rectangle and that of the table cell’s content rectangle.

See Also:
  Constant Field Values

#### BLOCK_ALIGN_AFTER

    public static final String BLOCK_ALIGN_AFTER

BlockAlign: After: After edge of the last child’s allocation rectangle aligned with that of the table cell’s content rectangle.

See Also:
  Constant Field Values

#### BLOCK_ALIGN_JUSTIFY

    public static final String BLOCK_ALIGN_JUSTIFY

BlockAlign: Justify: Children aligned with both the before and after edges of the table cell’s content rectangle. The first child shall be placed as described for `BLOCK_ALIGN_BEFORE` and the last child as described for `BLOCK_ALIGN_AFTER`, with equal spacing between the children. If there is only one child, it shall be aligned with the before edge only, as for `BLOCK_ALIGN_BEFORE`.

See Also:
  Constant Field Values

#### INLINE_ALIGN_START

    public static final String INLINE_ALIGN_START

InlineAlign: Start: Start edge of each child’s allocation rectangle aligned with that of the table cell’s content rectangle.

See Also:
  Constant Field Values

#### INLINE_ALIGN_CENTER

    public static final String INLINE_ALIGN_CENTER

InlineAlign: Center: Each child centered within the table cell. The distance between the start edges of the child’s allocation rectangle and the table cell’s content rectangle shall be the same as the distance between their end edges.

See Also:
  Constant Field Values

#### INLINE_ALIGN_END

    public static final String INLINE_ALIGN_END

InlineAlign: End: End edge of each child’s allocation rectangle aligned with that of the table cell’s content rectangle.

See Also:
  Constant Field Values

#### LINE_HEIGHT_NORMAL

    public static final String LINE_HEIGHT_NORMAL

LineHeight: NormalAdjust the line height to include any nonzero value specified for BaselineShift.

See Also:
  Constant Field Values

#### LINE_HEIGHT_AUTO

    public static final String LINE_HEIGHT_AUTO

LineHeight: Auto: Adjustment for the value of BaselineShift shall not be made.

See Also:
  Constant Field Values

#### TEXT_DECORATION_TYPE_NONE

    public static final String TEXT_DECORATION_TYPE_NONE

TextDecorationType: None: No text decoration

See Also:
  Constant Field Values

#### TEXT_DECORATION_TYPE_UNDERLINE

    public static final String TEXT_DECORATION_TYPE_UNDERLINE

TextDecorationType: Underline: A line below the text

See Also:
  Constant Field Values

#### TEXT_DECORATION_TYPE_OVERLINE

    public static final String TEXT_DECORATION_TYPE_OVERLINE

TextDecorationType: Overline: A line above the text

See Also:
  Constant Field Values

#### TEXT_DECORATION_TYPE_LINE_THROUGH

    public static final String TEXT_DECORATION_TYPE_LINE_THROUGH

TextDecorationType: LineThrough: A line through the middle of the text

See Also:
  Constant Field Values

#### RUBY_ALIGN_START

    public static final String RUBY_ALIGN_START

RubyAlign: Start: The content shall be aligned on the start edge in the inline-progression direction.

See Also:
  Constant Field Values

#### RUBY_ALIGN_CENTER

    public static final String RUBY_ALIGN_CENTER

RubyAlign: Center: The content shall be centered in the inline-progression direction.

See Also:
  Constant Field Values

#### RUBY_ALIGN_END

    public static final String RUBY_ALIGN_END

RubyAlign: End: The content shall be aligned on the end edge in the inline-progression direction.

See Also:
  Constant Field Values

#### RUBY_ALIGN_JUSTIFY

    public static final String RUBY_ALIGN_JUSTIFY

RubyAlign: Justify: The content shall be expanded to fill the available width in the inline-progression direction.

See Also:
  Constant Field Values

#### RUBY_ALIGN_DISTRIBUTE

    public static final String RUBY_ALIGN_DISTRIBUTE

RubyAlign: Distribute: The content shall be expanded to fill the available width in the inline-progression direction. However, space shall also be inserted at the start edge and end edge of the text. The spacing shall be distributed using a 1:2:1 (start:infix:end) ratio. It shall be changed to a 0:1:1 ratio if the ruby appears at the start of a text line or to a 1:1:0 ratio if the ruby appears at the end of the text line.

See Also:
  Constant Field Values

#### RUBY_POSITION_BEFORE

    public static final String RUBY_POSITION_BEFORE

RubyPosition: Before: The RT content shall be aligned along the before edge of the element.

See Also:
  Constant Field Values

#### RUBY_POSITION_AFTER

    public static final String RUBY_POSITION_AFTER

RubyPosition: After: The RT content shall be aligned along the after edge of the element.

See Also:
  Constant Field Values

#### RUBY_POSITION_WARICHU

    public static final String RUBY_POSITION_WARICHU

RubyPosition: Warichu: The RT and associated RP elements shall be formatted as a warichu, following the RB element.

See Also:
  Constant Field Values

#### RUBY_POSITION_INLINE

    public static final String RUBY_POSITION_INLINE

RubyPosition: Inline: The RT and associated RP elements shall be formatted as a parenthesis comment, following the RB element.

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_AUTO

    public static final String GLYPH_ORIENTATION_VERTICAL_AUTO

GlyphOrientationVertical: Auto

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_MINUS_180_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_MINUS_180_DEGREES

GlyphOrientationVertical: -180°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_MINUS_90_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_MINUS_90_DEGREES

GlyphOrientationVertical: -90°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_ZERO_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_ZERO_DEGREES

GlyphOrientationVertical: 0°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_90_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_90_DEGREES

GlyphOrientationVertical: 90°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_180_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_180_DEGREES

GlyphOrientationVertical: 180°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_270_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_270_DEGREES

GlyphOrientationVertical: 270°

See Also:
  Constant Field Values

#### GLYPH_ORIENTATION_VERTICAL_360_DEGREES

    public static final String GLYPH_ORIENTATION_VERTICAL_360_DEGREES

GlyphOrientationVertical: 360°

See Also:
  Constant Field Values

### Constructor Detail

#### PDLayoutAttributeObject

    public PDLayoutAttributeObject()

Default constructor.

#### PDLayoutAttributeObject

    public PDLayoutAttributeObject(COSDictionary dictionary)

Creates a new Layout attribute object with a given dictionary.

Parameters:
  `dictionary` - the dictionary

### Method Detail

#### getPlacement

    public String getPlacement()

Gets the positioning of the element with respect to the enclosing reference area and other content (Placement). The default value is `PLACEMENT_INLINE`.

Returns:
  the placement

#### setPlacement

    public void setPlacement(String placement)

Sets the positioning of the element with respect to the enclosing reference area and other content (Placement). The value should be one of:

- `PLACEMENT_BLOCK`,
- `PLACEMENT_INLINE`,
- `PLACEMENT_BEFORE`,
- `PLACEMENT_START`,
- `PLACEMENT_END`.

Parameters:
  `placement` - the placement

#### getWritingMode

    public String getWritingMode()

Gets the writing mode (WritingMode). The default value is `WRITING_MODE_LRTB`.

Returns:
  the writing mode

#### setWritingMode

    public void setWritingMode(String writingMode)

Sets the writing mode (WritingMode). The value should be one of:

- `WRITING_MODE_LRTB`,
- `WRITING_MODE_RLTB`,
- `WRITING_MODE_TBRL`.

Parameters:
  `writingMode` - the writing mode

#### getBackgroundColor

    public PDGamma getBackgroundColor()

Gets the background colour (BackgroundColor).

Returns:
  the background colour

#### setBackgroundColor

    public void setBackgroundColor(PDGamma backgroundColor)

Sets the background colour (BackgroundColor).

Parameters:
  `backgroundColor` - the background colour

#### getBorderColors

    public Object getBorderColors()

Gets the border colour (BorderColor).

Returns:
  a single border colour (`PDGamma`) or four border colours (`PDFourColours`)

#### setAllBorderColors

    public void setAllBorderColors(PDGamma borderColor)

Sets the same border colour for all four sides (BorderColor).

Parameters:
  `borderColor` - the border colour

#### setBorderColors

    public void setBorderColors(PDFourColours borderColors)

Sets the border colours for four sides separately (BorderColor).

Parameters:
  `borderColors` - the border colours

#### getBorderStyle

    public Object getBorderStyle()

Gets the border style (BorderStyle). The default value is `BORDER_STYLE_NONE`.

Returns:
  the border styles (a String or an array of four Strings)

#### setAllBorderStyles

    public void setAllBorderStyles(String borderStyle)

Sets the same border style for all four sides (BorderStyle). The value should be one of:

- `BORDER_STYLE_NONE`,
- `BORDER_STYLE_HIDDEN`,
- `BORDER_STYLE_DOTTED`,
- `BORDER_STYLE_DASHED`,
- `BORDER_STYLE_SOLID`,
- `BORDER_STYLE_DOUBLE`,
- `BORDER_STYLE_GROOVE`,
- `BORDER_STYLE_RIDGE`,
- `BORDER_STYLE_INSET`,
- `BORDER_STYLE_OUTSET`.

Parameters:
  `borderStyle` - the border style

#### setBorderStyles

    public void setBorderStyles(String[] borderStyles)

Sets the border styles for four sides separately (BorderStyle). The values should be of:

- `BORDER_STYLE_NONE`,
- `BORDER_STYLE_HIDDEN`,
- `BORDER_STYLE_DOTTED`,
- `BORDER_STYLE_DASHED`,
- `BORDER_STYLE_SOLID`,
- `BORDER_STYLE_DOUBLE`,
- `BORDER_STYLE_GROOVE`,
- `BORDER_STYLE_RIDGE`,
- `BORDER_STYLE_INSET`,
- `BORDER_STYLE_OUTSET`.

Parameters:
  `borderStyles` - the border styles (an array of four Strings)

#### getBorderThickness

    public Object getBorderThickness()

Gets the border thickness (BorderThickness).

Returns:
  the border thickness (a Float or an array of four floats)

#### setAllBorderThicknesses

    public void setAllBorderThicknesses(float borderThickness)

Sets the same border thickness for all four sides (BorderThickness).

Parameters:
  `borderThickness` - the border thickness

#### setAllBorderThicknesses

    public void setAllBorderThicknesses(int borderThickness)

Sets the same border thickness for all four sides (BorderThickness).

Parameters:
  `borderThickness` - the border thickness

#### setBorderThicknesses

    public void setBorderThicknesses(float[] borderThicknesses)

Sets the border thicknesses for four sides separately (BorderThickness).

Parameters:
  `borderThicknesses` - the border thickness (an array of four floats)

#### getPadding

    public Object getPadding()

Gets the padding (Padding). The default value is 0.

Returns:
  the padding (a Float or an array of float)

#### setAllPaddings

    public void setAllPaddings(float padding)

Sets the same padding for all four sides (Padding).

Parameters:
  `padding` - the padding

#### setAllPaddings

    public void setAllPaddings(int padding)

Sets the same padding for all four sides (Padding).

Parameters:
  `padding` - the padding

#### setPaddings

    public void setPaddings(float[] paddings)

Sets the paddings for four sides separately (Padding).

Parameters:
  `paddings` - the paddings (an array of four floats)

#### getColor

    public PDGamma getColor()

Gets the color to be used for drawing text and the default value for the colour of table borders and text decorations (Color).

Returns:
  the colour

#### setColor

    public void setColor(PDGamma color)

Sets the color to be used for drawing text and the default value for the colour of table borders and text decorations (Color).

Parameters:
  `color` - the colour

#### getSpaceBefore

    public float getSpaceBefore()

Gets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore). The default value is 0.

Returns:
  the space before

#### setSpaceBefore

    public void setSpaceBefore(float spaceBefore)

Sets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore).

Parameters:
  `spaceBefore` - the space before

#### setSpaceBefore

    public void setSpaceBefore(int spaceBefore)

Sets the amount of extra space preceding the before edge of the BLSE in the block-progression direction (SpaceBefore).

Parameters:
  `spaceBefore` - the space before

#### getSpaceAfter

    public float getSpaceAfter()

Gets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter). The default value is 0.

Returns:
  the space after

#### setSpaceAfter

    public void setSpaceAfter(float spaceAfter)

Sets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter).

Parameters:
  `spaceAfter` - the space after

#### setSpaceAfter

    public void setSpaceAfter(int spaceAfter)

Sets the amount of extra space following the after edge of the BLSE in the block-progression direction (SpaceAfter).

Parameters:
  `spaceAfter` - the space after

#### getStartIndent

    public float getStartIndent()

Gets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent). The default value is 0.

Returns:
  the start indent

#### setStartIndent

    public void setStartIndent(float startIndent)

Sets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent).

Parameters:
  `startIndent` - the start indent

#### setStartIndent

    public void setStartIndent(int startIndent)

Sets the distance from the start edge of the reference area to that of the BLSE in the inline-progression direction (StartIndent).

Parameters:
  `startIndent` - the start indent

#### getEndIndent

    public float getEndIndent()

Gets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent). The default value is 0.

Returns:
  the end indent

#### setEndIndent

    public void setEndIndent(float endIndent)

Sets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent).

Parameters:
  `endIndent` - the end indent

#### setEndIndent

    public void setEndIndent(int endIndent)

Sets the distance from the end edge of the BLSE to that of the reference area in the inline-progression direction (EndIndent).

Parameters:
  `endIndent` - the end indent

#### getTextIndent

    public float getTextIndent()

Gets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent). The default value is 0.

Returns:
  the text indent

#### setTextIndent

    public void setTextIndent(float textIndent)

Sets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent).

Parameters:
  `textIndent` - the text indent

#### setTextIndent

    public void setTextIndent(int textIndent)

Sets the additional distance in the inline-progression direction from the start edge of the BLSE, as specified by StartIndent, to that of the first line of text (TextIndent).

Parameters:
  `textIndent` - the text indent

#### getTextAlign

    public String getTextAlign()

Gets the alignment, in the inline-progression direction, of text and other content within lines of the BLSE (TextAlign). The default value is `TEXT_ALIGN_START`.

Returns:
  the text alignment

#### setTextAlign

    public void setTextAlign(String textIndent)

Sets the alignment, in the inline-progression direction, of text and other content within lines of the BLSE (TextAlign). The value should be one of:

- `TEXT_ALIGN_START`,
- `TEXT_ALIGN_CENTER`,
- `TEXT_ALIGN_END`,
- `TEXT_ALIGN_JUSTIFY`.

Parameters:
  `textIndent` - the text alignment

#### getBBox

    public PDRectangle getBBox()

Gets the bounding box.

Returns:
  the bounding box.

#### setBBox

    public void setBBox(PDRectangle bbox)

Sets the bounding box.

Parameters:
  `bbox` - the bounding box

#### getWidth

    public Object getWidth()

Gets the width of the element’s content rectangle in the inline-progression direction (Width). The default value is `WIDTH_AUTO`.

Returns:
  the width (a Float or a String)

#### setWidthAuto

    public void setWidthAuto()

Sets the width of the element’s content rectangle in the inline-progression direction (Width) to `WIDTH_AUTO`.

#### setWidth

    public void setWidth(float width)

Sets the width of the element’s content rectangle in the inline-progression direction (Width).

Parameters:
  `width` - the width

#### setWidth

    public void setWidth(int width)

Sets the width of the element’s content rectangle in the inline-progression direction (Width).

Parameters:
  `width` - the width

#### getHeight

    public Object getHeight()

Gets the height of the element’s content rectangle in the block-progression direction (Height). The default value is `HEIGHT_AUTO`.

Returns:
  the height (a Float or a String)

#### setHeightAuto

    public void setHeightAuto()

Sets the height of the element’s content rectangle in the block-progression direction (Height) to `HEIGHT_AUTO`.

#### setHeight

    public void setHeight(float height)

Sets the height of the element’s content rectangle in the block-progression direction (Height).

Parameters:
  `height` - the height

#### setHeight

    public void setHeight(int height)

Sets the height of the element’s content rectangle in the block-progression direction (Height).

Parameters:
  `height` - the height

#### getBlockAlign

    public String getBlockAlign()

Gets the alignment, in the block-progression direction, of content within the table cell (BlockAlign). The default value is `BLOCK_ALIGN_BEFORE`.

Returns:
  the block alignment

#### setBlockAlign

    public void setBlockAlign(String blockAlign)

Sets the alignment, in the block-progression direction, of content within the table cell (BlockAlign). The value should be one of:

- `BLOCK_ALIGN_BEFORE`,
- `BLOCK_ALIGN_MIDDLE`,
- `BLOCK_ALIGN_AFTER`,
- `BLOCK_ALIGN_JUSTIFY`.

Parameters:
  `blockAlign` - the block alignment

#### getInlineAlign

    public String getInlineAlign()

Gets the alignment, in the inline-progression direction, of content within the table cell (InlineAlign). The default value is `INLINE_ALIGN_START`.

Returns:
  the inline alignment

#### setInlineAlign

    public void setInlineAlign(String inlineAlign)

Sets the alignment, in the inline-progression direction, of content within the table cell (InlineAlign). The value should be one of

- `INLINE_ALIGN_START`,
- `INLINE_ALIGN_CENTER`,
- `INLINE_ALIGN_END`.

Parameters:
  `inlineAlign` - the inline alignment

#### getTBorderStyle

    public Object getTBorderStyle()

Gets the style of the border drawn on each edge of a table cell (TBorderStyle).

Returns:
  the border style.

#### setAllTBorderStyles

    public void setAllTBorderStyles(String tBorderStyle)

Sets the same table border style for all four sides (TBorderStyle). The value should be one of:

- `BORDER_STYLE_NONE`,
- `BORDER_STYLE_HIDDEN`,
- `BORDER_STYLE_DOTTED`,
- `BORDER_STYLE_DASHED`,
- `BORDER_STYLE_SOLID`,
- `BORDER_STYLE_DOUBLE`,
- `BORDER_STYLE_GROOVE`,
- `BORDER_STYLE_RIDGE`,
- `BORDER_STYLE_INSET`,
- `BORDER_STYLE_OUTSET`.

Parameters:
  `tBorderStyle` - the table border style

#### setTBorderStyles

    public void setTBorderStyles(String[] tBorderStyles)

Sets the style of the border drawn on each edge of a table cell (TBorderStyle). The values should be of:

- `BORDER_STYLE_NONE`,
- `BORDER_STYLE_HIDDEN`,
- `BORDER_STYLE_DOTTED`,
- `BORDER_STYLE_DASHED`,
- `BORDER_STYLE_SOLID`,
- `BORDER_STYLE_DOUBLE`,
- `BORDER_STYLE_GROOVE`,
- `BORDER_STYLE_RIDGE`,
- `BORDER_STYLE_INSET`,
- `BORDER_STYLE_OUTSET`.

Parameters:
  `tBorderStyles` - the table border styles

#### getTPadding

    public Object getTPadding()

Gets the offset to account for the separation between the table cell’s content rectangle and the surrounding border (TPadding). The default value is 0.

Returns:
  the table padding (a Float or an array of float)

#### setAllTPaddings

    public void setAllTPaddings(float tPadding)

Sets the same table padding for all four sides (TPadding).

Parameters:
  `tPadding` - the table padding

#### setAllTPaddings

    public void setAllTPaddings(int tPadding)

Sets the same table padding for all four sides (TPadding).

Parameters:
  `tPadding` - the table padding

#### setTPaddings

    public void setTPaddings(float[] tPaddings)

Sets the table paddings for four sides separately (TPadding).

Parameters:
  `tPaddings` - the table paddings (an array of four floats)

#### getBaselineShift

    public float getBaselineShift()

Gets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift). The default value is 0.

Returns:
  the baseline shift

#### setBaselineShift

    public void setBaselineShift(float baselineShift)

Sets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift).

Parameters:
  `baselineShift` - the baseline shift

#### setBaselineShift

    public void setBaselineShift(int baselineShift)

Sets the distance by which the element’s baseline shall be shifted relative to that of its parent element (BaselineShift).

Parameters:
  `baselineShift` - the baseline shift

#### getLineHeight

    public Object getLineHeight()

Gets the element’s preferred height in the block-progression direction (LineHeight). The default value is `LINE_HEIGHT_NORMAL`.

Returns:
  the line height (a Float or a String)

#### setLineHeightNormal

    public void setLineHeightNormal()

Sets the element’s preferred height in the block-progression direction (LineHeight) to `LINE_HEIGHT_NORMAL`.

#### setLineHeightAuto

    public void setLineHeightAuto()

Sets the element’s preferred height in the block-progression direction (LineHeight) to `LINE_HEIGHT_AUTO`.

#### setLineHeight

    public void setLineHeight(float lineHeight)

Sets the element’s preferred height in the block-progression direction (LineHeight).

Parameters:
  `lineHeight` - the line height

#### setLineHeight

    public void setLineHeight(int lineHeight)

Sets the element’s preferred height in the block-progression direction (LineHeight).

Parameters:
  `lineHeight` - the line height

#### getTextDecorationColor

    public PDGamma getTextDecorationColor()

Gets the colour to be used for drawing text decorations (TextDecorationColor).

Returns:
  the text decoration colour

#### setTextDecorationColor

    public void setTextDecorationColor(PDGamma textDecorationColor)

Sets the colour to be used for drawing text decorations (TextDecorationColor).

Parameters:
  `textDecorationColor` - the text decoration colour

#### getTextDecorationThickness

    public float getTextDecorationThickness()

Gets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).

Returns:
  the text decoration thickness

#### setTextDecorationThickness

    public void setTextDecorationThickness(float textDecorationThickness)

Sets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).

Parameters:
  `textDecorationThickness` - the text decoration thickness

#### setTextDecorationThickness

    public void setTextDecorationThickness(int textDecorationThickness)

Sets the thickness of each line drawn as part of the text decoration (TextDecorationThickness).

Parameters:
  `textDecorationThickness` - the text decoration thickness

#### getTextDecorationType

    public String getTextDecorationType()

Gets the type of text decoration (TextDecorationType). The default value is `TEXT_DECORATION_TYPE_NONE`.

Returns:
  the type of text decoration

#### setTextDecorationType

    public void setTextDecorationType(String textDecorationType)

Sets the type of text decoration (TextDecorationType). The value should be one of:

- `TEXT_DECORATION_TYPE_NONE`,
- `TEXT_DECORATION_TYPE_UNDERLINE`,
- `TEXT_DECORATION_TYPE_OVERLINE`,
- `TEXT_DECORATION_TYPE_LINE_THROUGH`.

Parameters:
  `textDecorationType` - the type of text decoration

#### getRubyAlign

    public String getRubyAlign()

Gets the justification of the lines within a ruby assembly (RubyAlign). The default value is `RUBY_ALIGN_DISTRIBUTE`.

Returns:
  the ruby alignment

#### setRubyAlign

    public void setRubyAlign(String rubyAlign)

Sets the justification of the lines within a ruby assembly (RubyAlign). The value should be one of:

- `RUBY_ALIGN_START`,
- `RUBY_ALIGN_CENTER`,
- `RUBY_ALIGN_END`,
- `RUBY_ALIGN_JUSTIFY`,
- `RUBY_ALIGN_DISTRIBUTE`,

Parameters:
  `rubyAlign` - the ruby alignment

#### getRubyPosition

    public String getRubyPosition()

Gets the placement of the RT structure element relative to the RB element in a ruby assembly (RubyPosition). The default value is `RUBY_POSITION_BEFORE`.

Returns:
  the ruby position

#### setRubyPosition

    public void setRubyPosition(String rubyPosition)

Sets the placement of the RT structure element relative to the RB element in a ruby assembly (RubyPosition). The value should be one of:

- `RUBY_POSITION_BEFORE`,
- `RUBY_POSITION_AFTER`,
- `RUBY_POSITION_WARICHU`,
- `RUBY_POSITION_INLINE`.

Parameters:
  `rubyPosition` - the ruby position

#### getGlyphOrientationVertical

    public String getGlyphOrientationVertical()

Gets the orientation of glyphs when the inline-progression direction is top to bottom or bottom to top (GlyphOrientationVertical). The default value is `GLYPH_ORIENTATION_VERTICAL_AUTO`.

Returns:
  the vertical glyph orientation

#### setGlyphOrientationVertical

    public void setGlyphOrientationVertical(String glyphOrientationVertical)

Sets the orientation of glyphs when the inline-progression direction is top to bottom or bottom to top (GlyphOrientationVertical). The value should be one of:

- `GLYPH_ORIENTATION_VERTICAL_AUTO`,
- `GLYPH_ORIENTATION_VERTICAL_MINUS_180_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_MINUS_90_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_ZERO_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_90_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_180_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_270_DEGREES`,
- `GLYPH_ORIENTATION_VERTICAL_360_DEGREES`.

Parameters:
  `glyphOrientationVertical` - the vertical glyph orientation

#### getColumnCount

    public int getColumnCount()

Gets the number of columns in the content of the grouping element (ColumnCount). The default value is 1.

Returns:
  the column count

#### setColumnCount

    public void setColumnCount(int columnCount)

Sets the number of columns in the content of the grouping element (ColumnCount).

Parameters:
  `columnCount` - the column count

#### getColumnGap

    public Object getColumnGap()

Gets the desired space between adjacent columns in the inline-progression direction (ColumnGap).

Returns:
  the column gap (FLoat or array of floats)

#### setColumnGap

    public void setColumnGap(float columnGap)

Sets the desired space between all columns in the inline-progression direction (ColumnGap).

Parameters:
  `columnGap` - the column gap

#### setColumnGap

    public void setColumnGap(int columnGap)

Sets the desired space between all columns in the inline-progression direction (ColumnGap).

Parameters:
  `columnGap` - the column gap

#### setColumnGaps

    public void setColumnGaps(float[] columnGaps)

Sets the desired space between adjacent columns in the inline-progression direction (ColumnGap), the first element specifying the space between the first and second columns, the second specifying the space between the second and third columns, and so on.

Parameters:
  `columnGaps` - the column gaps

#### getColumnWidths

    public Object getColumnWidths()

Gets the desired width of the columns, measured in default user space units in the inline-progression direction (ColumnWidths).

Returns:
  the column widths (Float or array of floats)

#### setAllColumnWidths

    public void setAllColumnWidths(float columnWidth)

Sets the same column width for all columns (ColumnWidths).

Parameters:
  `columnWidth` - the column width

#### setAllColumnWidths

    public void setAllColumnWidths(int columnWidth)

Sets the same column width for all columns (ColumnWidths).

Parameters:
  `columnWidth` - the column width

#### setColumnWidths

    public void setColumnWidths(float[] columnWidths)

Sets the column widths for the columns separately (ColumnWidths).

Parameters:
  `columnWidths` - the column widths

#### toString

    public String toString()

Overrides:
  `toString` in class `PDAttributeObject`